package com.example.jersey5156;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;
import org.apache.logging.log4j.jul.Log4jBridgeHandler;

@WebListener("Entry point")
public class Startup implements ServletContextListener {

    @Override
    public void contextInitialized(ServletContextEvent event) {
        // redirect JUL directly to Log4j2, and only for this web application
        // https://logging.apache.org/log4j/2.x/log4j-jul/index.html
        java.util.logging.Logger rootLogger = java.util.logging.LogManager.getLogManager().getLogger("");
        for (java.util.logging.Handler handler : rootLogger.getHandlers()) {
            rootLogger.removeHandler(handler);
        }
        Log4jBridgeHandler handler = new Log4jBridgeHandler(false, null, true) {
            @Override
            public void publish(java.util.logging.LogRecord record) {
                // for some reason, Log4jBridgeHandler doesn't handle the filter
                if (getFilter() == null || getFilter().isLoggable(record)) {
                    super.publish(record);
                }
            }
        };
        handler.setFilter((java.util.logging.LogRecord record) -> {
            return true;
        });
        rootLogger.addHandler(handler);
    }

    @Override
    public void contextDestroyed(ServletContextEvent event) {
        // nothing to do
    }
    
}
