package com.example.jersey5156.rest.base;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import javax.ws.rs.ext.ExceptionMapper;
import javax.ws.rs.ext.Provider;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@Provider
public class RestUncaughtExceptions implements ExceptionMapper<Throwable> {
    
    private static final Logger LOG = LogManager.getLogger(RestUncaughtExceptions.class);

    @Override
    public Response toResponse(Throwable ex) {
        if (WebApplicationException.class.isInstance(ex)) {
            return ((WebApplicationException) ex).getResponse();
        } else {
            LOG.error("Uncaught exception.", ex);
            return Response.serverError().build();
        }
    }
    
}
